$LiveMenu::SceneCount = 12;

$LiveMenu::SceneSave[0] = "ACM City";
$LiveMenu::SceneCameraTransform[0] = "-88.8167 16.1261 4.68426 0.0364567 -0.177358 0.983471 2.74266";
$LiveMenu::ScenePlayerTransform[0] = "-85.3402 10.4036 1.01 0 0 -1 1.59372";
$LiveMenu::ScenePlayerThread[0] = "sit";

$LiveMenu::SceneSave[1] = "ACM City";
$LiveMenu::SceneCameraTransform[1] = "2.71123 3.83397 5.27153 -0.071636 -0.137929 0.987848 4.08967";
$LiveMenu::ScenePlayerTransform[1] = "-8.87044 -0.451594 0.409825 0 0 1 1.54796";

$LiveMenu::SceneSave[2] = "ACM City";
$LiveMenu::SceneCameraTransform[2] = "-91.279 -73.385 19.1041 0.290845 -0.184407 0.938831 1.18798";
$LiveMenu::ScenePlayerTransform[2] = "-81.8906 -70.9311 13.203 0 0 1 1.108";

$LiveMenu::SceneSave[3] = "ACM City";
$LiveMenu::SceneCameraTransform[3] = "-54.9288 -2.38852 18.0215 0.0278958 -0.0118834 0.99954 0.805756";
$LiveMenu::ScenePlayerTransform[3] = "-48.6032 1.86879 15.8036 0 0 1.00003 0.0412135";

$LiveMenu::SceneSave[4] = "ACM City";
$LiveMenu::SceneCameraTransform[4] = "-69.4313 -89.1013 2.95795 0.260612 0.0714378 -0.962797 0.554737";
$LiveMenu::ScenePlayerTransform[4] = "-71.77 -81.4512 0.41 0 0 -1 1.2735";

$LiveMenu::SceneSave[5] = "ACM City";
$LiveMenu::SceneCameraTransform[5] = "100.913 -35.9091 10.3358 0.206629 -0.129213 0.96985 1.14539";
$LiveMenu::ScenePlayerTransform[5] = "112.935 -32.3842 5.80158 0 0 1 3.9218";

$LiveMenu::SceneSave[6] = "A.T.C. Fort";
$LiveMenu::SceneCameraTransform[6] = "65.9978 1.53882 11.2056 0.0240162 -0.03148 0.999216 1.83893";
$LiveMenu::ScenePlayerTransform[6] = "76.7911 0.901824 8.6107 0 0 -1 1.78365";

$LiveMenu::SceneSave[7] = "A.T.C. Fort";
$LiveMenu::SceneCameraTransform[7] = "104.982 -27.5928 11.3999 0.0695492 -0.0389638 0.996817 1.02405";
$LiveMenu::ScenePlayerTransform[7] = "132.374 -18.9323 8.6 0 0 -1 1.59804";

$LiveMenu::SceneSave[8] = "Apartment";
$LiveMenu::SceneCameraTransform[8] = "146.427 92.2463 6.16693 0.202098 -0.0322489 0.978834 0.323199";
$LiveMenu::ScenePlayerTransform[8] = "157.002 107.685 0.81 0 0 -1 0.758277";

$LiveMenu::SceneSave[9] = "Arch of Constantine";
$LiveMenu::SceneCameraTransform[9] = "-71.9302 -73.9737 24.7293 0.233048 -0.139832 0.962359 1.11502";
$LiveMenu::ScenePlayerTransform[9] = "-55.1989 -70.3944 21.4013 0 0 -1 1.20975";

$LiveMenu::SceneSave[10] = "BLOKO Blupo";
$LiveMenu::SceneCameraTransform[10] = "-56.8385 -16.8307 15.8912 -0.0585858 -0.161373 0.985153 3.82855";
$LiveMenu::ScenePlayerTransform[10] = "-64.7631 -23.4468 11.0102 0 0 1 2.67659";
$LiveMenu::ScenePlayerThread[10] = "armReadyBoth";

$LiveMenu::SceneSave[11] = "Gazebo Garden";
$LiveMenu::SceneCameraTransform[11] = "-2.45143 45.1793 3.66508 0.0531448 0.00536106 -0.998575 0.201358";
$LiveMenu::ScenePlayerTransform[11] = "-3.58917 59.8101 1.61076 0 0 1 3.69515";

package LiveMenuPackage {
	function GameConnection::onClientEnterGame(%this) {
		Parent::onClientEnterGame(%this);

		if (ServerConnection.isLiveMenuServer) {
			%this.schedule(0, spawnInLiveMenu);
		}
	}

	function PlayGUI::onWake(%this) {
		Parent::onWake(%this);

		if (ServerConnection.isLiveMenuServer) {
			Canvas.pushDialog(MainMenuButtonsGUI);
			MoveMap.pop();

			Crosshair.setVisible(false);
			PlayGUI_ShapeNameHUD.setVisible(false);
		}
	}

	function JoinServerGUI::join(%this) {
		%this.isJoining = true;
		Parent::join(%this);
		%this.isJoining = "";
	}

	function GUIControl::onSleep(%this) {
		if (isObject(%this) && ServerConnection.isLiveMenuServer) {
			%name = %this.getName();

			if (%name $= JoinServerGUI || %name $= GameModeGUI || %name $= ServerSettingsGUI || %name $= SteamGreenLightGUI) {
				Canvas.pushDialog(MainMenuButtonsGUI);
			}
		}
	}

	function Canvas::pushDialog(%this, %control) {
		if (!isObject(%control) || (!ServerConnection.isLiveMenuServer && !$StartingLiveMenuServer)) {
			Parent::pushDialog(%this, %control);
			return;
		}

		%name = %control.getName();

		if (%name !$= "NewChatHUD" && %name !$= "NewMessageHUD") {
			Parent::pushDialog(%this, %control);
		}
	}

	function Canvas::setContent(%this, %control) {
		%name = isObject(%control) ? %control.getName() : "";
		%liveMenu = ($StartingLiveMenuServer || ServerConnection.isLiveMenuServer);

		if (%name $= "LoadingGUI" && %liveMenu) {
			return;
		}

		Parent::setContent(%this, %control);

		if ($HasOpenedLiveMenuOnce && %name $= "MainMenuGUI" && !JoinServerGUI.isJoining) {
			schedule(0, 0, startLiveMenuServer);
		}
	}

	function MM_AuthBar::blinkSuccess(%this) {
		Parent::blinkSuccess(%this);

		if (!$HasOpenedLiveMenuOnce) {
			startLiveMenuServer();
		}
	}

	function messageClient(%client, %tag, %message, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n,
		%o, %p, %q, %r, %s, %t, %u, %v, %w, %x, %y, %z
	) {
		if (!ServerConnection.isLiveMenuServer) {
			Parent::messageClient(%client, %tag, %message, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n,
				%o, %p, %q, %r, %s, %t, %u, %v, %w, %x, %y, %z
			);
		}
	}

	function deactivateServerPackages() {
		Parent::deactivateServerPackages();
		activatePackage("LiveMenuPackage");
	}

	function disconnect(%bool) {
		if (!ServerConnection.isLiveMenuServer || JoinServerGUI.isJoining) {
			parent::disconnect(%bool);
		}
	}
};

activatePackage("LiveMenuPackage");

function startLiveMenuServer() {
	$HasOpenedLiveMenuOnce = true;
	$StartingLiveMenuServer = true;

	MainMenuGUI.clickStart();

	for (%i = 0; %i < $GameModeGUI::GameModeCount; %i++) {
		if ($GameModeGUI::GameMode[%i] $= "Add-Ons/GameMode_Freebuild/gamemode.txt") {
			GameModeGUI.clickGameMode(%i);
			break;
		}
	}

	if (%i == $GameModeGUI::GameModeCount) {
		messageBoxOK("ERROR", "Unable to find the Freebuild gamemode for Live Menu.");
		return;
	}

	GameModeGUI.clickSelect();
	schedule(0, 0, startLiveMenuServerStage2);
}

function startLiveMenuServerStage2() {
	ServerSettingsGUI.clickSinglePlayer();
	schedule(0, 0, startLiveMenuServerStage3);
}

function startLiveMenuServerStage3() {
	ServerSettingsGUI.clickLaunchGame();

	ServerConnection.isLiveMenuServer = true;
	ServerConnection.liveMenuScene = getRandom(0, $LiveMenu::SceneCount - 1);

	serverDirectSaveFileLoad("saves/" @ $LiveMenu::SceneSave[ServerConnection.liveMenuScene] @ ".bls", 3, "", 2);
	$StartingLiveMenuServer = "";
}

function GameConnection::spawnInLiveMenu(%this) {
	%this.camera.setTransform($LiveMenu::SceneCameraTransform[ServerConnection.liveMenuScene]);
	%this.player.setTransform($LiveMenu::ScenePlayerTransform[ServerConnection.liveMenuScene]);

	%this.camera.setControlObject(%this.player);
	%this.setControlObject(%this.camera);

	if ($LiveMenu::ScenePlayerThread[ServerConnection.liveMenuScene] !$= "") {
		%this.player.playThread(0, $LiveMenu::ScenePlayerThread[ServerConnection.liveMenuScene]);
	}
}
